import { world, system, BlockPermutation } from '@minecraft/server'

world.afterEvents.entitySpawn.subscribe(({ entity }) => {
    if(entity.typeId === "gst:jump_entity") {
        world.scoreboard.getObjective("gst:score").setScore(entity, 0);
        entity.nameTag = "§e0"
        entity.applyImpulse({ x: 0, y: 0.5, z: 0 });
        entity.addEffect("slow_falling",9999999,{ amplifier: 0, showParticles: false });
        system.run(() => {
            for(const player of world.getAllPlayers()) {
                player.onScreenDisplay.setTitle({translate: 'gst.start_game.title'});
            }
        });
    }
    if(entity.typeId === "gst:wood_obstacle") {
        if(!entity.isValid() || entity === undefined) return;
        const styleBlock = world.getDimension("overworld").getBlock({ x: -27, y: -60, z: -24 });
        entity.setProperty('gst:type', Math.floor(Math.random()*13));
        if(styleBlock.permutation.matches("minecraft:iron_block")) {
            entity.setProperty("gst:style","ss")
        }
        if(styleBlock.permutation.matches("minecraft:gold_block")) {
            entity.setProperty("gst:style","flappy")
        }
        system.runTimeout(() => {
            if(!entity.isValid() || entity === undefined) return;
            if(entity.getProperty('gst:type') === 0) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -42.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -42.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 1) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -44.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -44.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 2) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -46.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -46.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 3) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -48.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -48.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 4) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -41.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -41.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 5) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -43.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -43.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 6) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -45.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -45.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 7) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -47.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -47.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 8) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -49.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -49.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 9) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -49.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -42.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -49.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -42.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 10) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -43.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -48.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -43.5, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -48.5, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 11) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -49, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -48, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -50, z: entity.location.z});
                return;
            }
            if(entity.getProperty('gst:type') === 12) {
                entity.dimension.spawnEntity("gst:minecoin", { x: entity.location.x, y: -43, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -42, z: entity.location.z});
                entity.dimension.spawnEntity("gst:hitbox_entity", { x: entity.location.x, y: -44, z: entity.location.z});
                return;
            }
        },2);
    }
});