import { ActionFormData } from "@minecraft/server-ui"
import { world, system, BlockPermutation } from "@minecraft/server"

class Mains {

    Start(player) {
        const playerCount = world.scoreboard.getObjective("gst:player_count").getScore(player)
        const highscore = world.scoreboard.getObjective("gst:highscore").getScore(player);
        const coinValue = player.getProperty("gst:coins");
        const form = new ActionFormData()
            form.title({translate: 'gst.title.start'})
            form.body({"rawtext":[{"text":`§b${player.name}\n`},{"translate":"gst.best.score"},{"text":`${highscore}\n`},{"translate":"gst.current.coins"},{"text":`${coinValue}\n\n`},{"translate": "gst.online.players"},{"text":` §f${playerCount}§e/4§r`}]});
            form.button({translate: 'gst.button.start'},'textures/gst/ui/menu_buttons/start_button')// 0
            form.button({translate: 'gst.button.backgrounds'},'textures/gst/ui/menu_buttons/background_button')// 1
        form.show(player).then((data) => {
            if (data.selection === 0) {
                const startBlock = player.dimension.getBlock({ x: -27, y: -57, z: -16 });
                const timerBlock = player.dimension.getBlock({ x: -19, y: -57, z: -16 });
                startBlock.setPermutation(BlockPermutation.resolve("minecraft:redstone_block"));
                timerBlock.setPermutation(BlockPermutation.resolve("minecraft:redstone_block"));
                player.runCommandAsync('inputpermission set @a movement disabled');
                player.runCommandAsync('inputpermission set @a camera disabled');
                player.runCommandAsync('event entity @e[family=gst_button] gst:despawn');
                return;
            }
            if (data.selection === 1) {
                Main.Backgrounds(player);
            }
        })
    }
    Info(player) {
        const form = new ActionFormData()
            form.title({translate: 'gst.title.info'})
            form.body({"rawtext":[{"translate": "gst.text_0.info"},{"text":"\n\n"},{"translate":"gst.text_0_1.info"},{"text":"\n"},{"translate":"gst.text_0_2.info"},{"text":"\n\n"},{"translate":"gst.text_1.info"},{"text":"\n"},{"translate":"gst.text_2.info"},{"text":"\n"},{"translate":"gst.text_3.info"},{"text":"\n"},{"translate":"gst.text_4.info"},{"text":"\n\n"},{"translate":"gst.text_5.info"},{"text":"\n\n"},{"translate":"gst.text_6.info"}]});
            form.button({translate: 'gst.button.credits'})// 0
            form.button({translate: 'gst.button.back'})// 1
        form.show(player).then((data) => {
            if (data.selection === 0) {
                Main.Credits(player)
            }
            if (data.selection === 1) {
                Main.Start(player);
            }
        })
    }
    Credits(player) {
        const form = new ActionFormData()
            form.title({translate: 'gst.title.credits'})
            form.body({"rawtext":[{"translate": "gst.text_0.credits"},{"text":"\n\n"},{"translate":"gst.text_1.credits"},{"text":"\n"},{"translate":"gst.text_2.credits"},{"text":"\n"},{"text":"§aGamertag:§r Gusta 23324585"},{"text":"\n"},{"text":"§7Flappy Chicken v1.0"},{"text":"\n"},{"text":"§7Minecraft Bedrock 1.20.80+"}]});
            form.button({translate: 'gst.button.back'})// 0
        form.show(player).then((data) => {
            if (data.selection === 0) {
                Main.Info(player);
            } else {
                player.onScreenDisplay.setActionBar({translate:'gst.text_3.credits'});
            }
        })
    }
    Skins(player) {
        const highscore = world.scoreboard.getObjective("gst:highscore").getScore(player);
        const unlockedCharacters = player.getProperty("gst:unlocked_characters");
        const currentCharacter = player.getProperty("gst:character");
        const coinValue = player.getProperty("gst:coins");
        const form = new ActionFormData()
            form.title({translate: 'gst.title.skins'})
            if(currentCharacter === "chicken"){form.body({"rawtext":[{"translate":"gst.current.coins"},{"text":`§g${coinValue}\n`},{"translate":"gst.chicken.current_character"}]})};
            if(currentCharacter === "bee"){form.body({"rawtext":[{"translate":"gst.current.coins"},{"text":`§g${coinValue}\n`},{"translate":"gst.bee.current_character"}]})};
            if(currentCharacter === "parrot"){form.body({"rawtext":[{"translate":"gst.current.coins"},{"text":`§g${coinValue}\n`},{"translate":"gst.parrot.current_character"}]})};
            if(currentCharacter === "allay"){form.body({"rawtext":[{"translate":"gst.current.coins"},{"text":`§g${coinValue}\n`},{"translate":"gst.allay.current_character"}]})};
            if(currentCharacter === "bird"){form.body({"rawtext":[{"translate":"gst.current.coins"},{"text":`§g${coinValue}\n`},{"translate":"gst.bird.current_character"}]})};
            form.button({translate: 'gst.button.chicken'},"textures/gst/ui/character_buttons/chicken_button") // 0 Chicken
            if(unlockedCharacters < 1){form.button({"rawtext":[{"translate":"gst.button.bee"},{"text":`\n20`}]},"textures/gst/ui/character_buttons/bee_button")}// 1 Bee Locked
            if(unlockedCharacters >= 1){form.button({"rawtext":[{"translate":"gst.button.bee"}]},"textures/gst/ui/character_buttons/bee_button")}// 1 Bee Unlocked
            if(unlockedCharacters < 2){form.button({"rawtext":[{"translate":"gst.button.parrot"},{"text":`\n35`}]},"textures/gst/ui/character_buttons/parrot_button")}// 2 Parrot Locked
            if(unlockedCharacters >= 2){form.button({"rawtext":[{"translate":"gst.button.parrot"}]},"textures/gst/ui/character_buttons/parrot_button")}// 2 Parrot Unlocked
            if(unlockedCharacters < 3){form.button({"rawtext":[{"translate":"gst.button.allay"},{"text":`\n50`}]},"textures/gst/ui/character_buttons/allay_button")}// 3 Allay Locked
            if(unlockedCharacters >= 3){form.button({"rawtext":[{"translate":"gst.button.allay"}]},"textures/gst/ui/character_buttons/allay_button")}// 3 Allay Unlocked
            if(highscore < 115){form.button({"rawtext":[{"translate":"gst.button.secret"},{"text":"\n"},{"translate":"gst.highscore.tip"},{"text":" 115"}]},"textures/gst/ui/character_buttons/secret_button")}// 4 bird locked
            if(highscore >= 115){form.button({"rawtext":[{"translate":"gst.button.bird"}]},"textures/gst/ui/character_buttons/bird_button")}// 4 bird unlocked
            form.button({translate: 'gst.button.back'});// 4
        form.show(player).then((data) => {
            if (data.selection === 5) {
                Main.Start(player);
                return;
            }
            if(data.selection === undefined) return;
            if (data.selection === 0) {
                player.setProperty("gst:character","chicken");
                player.playSound("mob.chicken.say");
                player.onScreenDisplay.setActionBar({translate: 'gst.chicken.selected'});
                return;
            }// ^^^ chicken
            if (data.selection === 1 && unlockedCharacters < 1 && coinValue < 20) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.no_coins.tip'});
                return;
            }
            if (data.selection === 1 && unlockedCharacters === 0 && coinValue >= 20) {
                player.onScreenDisplay.setActionBar({translate: 'gst.character.unlocked'});
                player.setProperty("gst:unlocked_characters", 1);
                player.setProperty("gst:coins",coinValue -20);
                system.runTimeout(() => {
                    Main.Skins(player)
                },2);
                return;
            }
            if (data.selection === 1 && unlockedCharacters >= 1) {
                player.setProperty("gst:character","bee");
                player.playSound("mob.bee.hurt");
                player.onScreenDisplay.setActionBar({translate: 'gst.bee.selected'});
                return;
            }// ^^^ bee
            if (data.selection === 2 && unlockedCharacters < 2 && coinValue < 35) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.no_coins.tip'});
                return;
            }
            if (data.selection === 2 && unlockedCharacters === 1 && coinValue >= 35) {
                player.onScreenDisplay.setActionBar({translate: 'gst.character.unlocked'});
                player.setProperty("gst:unlocked_characters", 2);
                player.setProperty("gst:coins",coinValue -35);
                system.runTimeout(() => {
                    Main.Skins(player)
                },2);
                return;
            }
            if (data.selection === 2 && unlockedCharacters >= 2) {
                player.setProperty("gst:character","parrot");
                player.playSound("mob.parrot.idle");
                player.onScreenDisplay.setActionBar({translate: 'gst.parrot.selected'});
                return;
            }// ^^^ parrot
            if (data.selection === 3 && unlockedCharacters < 3 && coinValue < 50) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.no_coins.tip'});
                return;
            }
            if (data.selection === 3 && unlockedCharacters === 2 && coinValue >= 50) {
                player.onScreenDisplay.setActionBar({translate: 'gst.character.unlocked'});
                player.setProperty("gst:unlocked_characters", 3);
                player.setProperty("gst:coins",coinValue -50);
                system.runTimeout(() => {
                    Main.Skins(player)
                },2);
                return;
            }
            if (data.selection === 3 && unlockedCharacters >= 3) {
                player.setProperty("gst:character","allay");
                player.playSound("mob.allay.idle");
                player.onScreenDisplay.setActionBar({translate: 'gst.allay.selected'});
                return;
            }// ^^^ allay
            if (data.selection === 4 && highscore < 115) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.secret_bird.selected'});
                return;
            }
            if (data.selection === 4 && highscore >= 115) {
                player.setProperty("gst:character","bird");
                player.playSound("mob.parrot.idle");
                player.onScreenDisplay.setActionBar({translate: 'gst.bird.selected'});
                return;
            }// ^^^ bird
            else {
                return;
            }
        });
    }
    Backgrounds(player) {
        const highscore = world.scoreboard.getObjective("gst:highscore").getScore(player);
        const backgroundBlock = player.dimension.getBlock({ x: -27, y: -60, z: -24 });
        const backgrounds = player.getProperty("gst:backgrounds")
        const coinValue = player.getProperty("gst:coins");
        const form = new ActionFormData()
            form.title({translate: 'gst.title.backgrounds'})
            form.body({"rawtext":[{"translate":"gst.current.coins"},{"text":`§g${coinValue}\n`},{"translate":"gst.body.backgrounds"}]});
            form.button({translate: 'gst.button.day_background'},'textures/gst/ui/background_buttons/day')// 0
            if(backgrounds <= 1){form.button({"rawtext":[{"translate": "gst.button.night_background"},{"text":`\n15`}]},'textures/gst/ui/background_buttons/night')}// 1
            if(backgrounds > 1){form.button({translate: 'gst.button.night_background'},'textures/gst/ui/background_buttons/night')}// 1
            if(backgrounds <= 2){form.button({"rawtext":[{"translate": "gst.button.ss_background"},{"text":`\n20`}]},'textures/gst/ui/background_buttons/ss')}// 2
            if(backgrounds > 2){form.button({translate: 'gst.button.ss_background'},'textures/gst/ui/background_buttons/ss')}// 2
            if(highscore < 115){form.button({"rawtext":[{"translate":"gst.button.secret"},{"text":"\n"},{"translate":"gst.highscore.tip"},{"text":" 115"}]},"textures/gst/ui/character_buttons/secret_button")}// 3
            if(highscore >= 115){form.button({"rawtext":[{"translate":"gst.button.flappy_background"}]},"textures/gst/ui/background_buttons/flappy")}// 3
            form.button({translate: 'gst.button.back'});// 4
        form.show(player).then((data) => {
            if(data.selection === 4) {
                Main.Start(player)
                return
            }
            if(data.selection === undefined) return;
            if(data.selection === 0) {
                world.sendMessage({translate: 'gst.background_day.active'});
                backgroundBlock.setPermutation(BlockPermutation.resolve("minecraft:diamond_block"));
                Main.Start(player)
                return;
            }// day
            if(data.selection === 1 && backgrounds < 2 && coinValue < 15) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.no_coins.tip'});
                return;
            }
            if(data.selection === 1 && backgrounds === 1 && coinValue >= 15) {
                player.setProperty("gst:coins",coinValue -15);
                player.setProperty("gst:backgrounds",2);
                player.onScreenDisplay.setActionBar({translate: 'gst.background.unlocked'});
                system.runTimeout(() => {
                    Main.Backgrounds(player)
                },2);
                return;
            }
            if(data.selection === 1 && backgrounds >= 2) {
                world.sendMessage({translate: 'gst.background_night.active'});
                backgroundBlock.setPermutation(BlockPermutation.resolve("minecraft:emerald_block"));
                Main.Start(player)
                return;
            }// night
            if(data.selection === 2 && backgrounds < 3 && coinValue < 20) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.no_coins.tip'});
                return;
            }
            if(data.selection === 2 && backgrounds === 2 && coinValue >= 20) {
                player.setProperty("gst:coins",coinValue -20);
                player.setProperty("gst:backgrounds",3);
                world.sendMessage({translate: 'gst.space.shooter'});
                player.onScreenDisplay.setActionBar({translate: 'gst.background.unlocked'});
                return;
            }
            if(data.selection === 2 && backgrounds >= 3) {
                world.sendMessage({translate: 'gst.background_ss.active'});
                backgroundBlock.setPermutation(BlockPermutation.resolve("minecraft:iron_block"));
                Main.Start(player)
                return;
            }// ss
            if (data.selection === 3 && highscore < 115) {
                player.playSound("gst.no.coin");
                player.onScreenDisplay.setActionBar({translate: 'gst.secret_bird.selected'});
                return;
            }
            if (data.selection === 3 && highscore >= 115) {
                world.sendMessage({translate: 'gst.background_flappy.active'});
                backgroundBlock.setPermutation(BlockPermutation.resolve("minecraft:gold_block"));
                Main.Start(player)
                return;
            }// secret
        })
    }
}

export const Main = new Mains()